﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;
using Infragistics.Win.UltraWinProgressBar;
using System.Diagnostics;

namespace WindowsFormsApplication35
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            DataTable dt = DummyDataCreator.GetData(10, new Type[] { typeof(int), typeof(int) });
            this.ultraGrid1.SetDataBinding(dt, null);

            this.ultraGrid1.UseOsThemes = Infragistics.Win.DefaultableBoolean.False;

            this.ultraGrid1.CreationFilter = new MyCreationFilter();
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];

            UltraGridColumn column1 = band.Columns["Int32 1"];
            column1.MinValue = 0;
            column1.MaxValue = 100;
            column1.CellAppearance.TextHAlign = HAlign.Right;
            column1.EditorComponent = this.ultraProgressBar1;


            UltraGridColumn column2 = band.Columns["Int32 2"];
            var percentSettings1 = this.ultraProgressBar2.PercentSettings.Add(0);
            percentSettings1.FillAppearance.BackColor = Color.Red;
            var percentSettings2 = this.ultraProgressBar2.PercentSettings.Add(65);
            percentSettings2.FillAppearance.BackColor = Color.Green;
            column2.MinValue = 0;
            column2.MaxValue = 100;
            column2.CellAppearance.TextHAlign = HAlign.Right;
            column2.EditorComponent = this.ultraProgressBar2;      
        }
    }

    public class MyCreationFilter : IUIElementCreationFilter
    {
        Image image1 = DummyDataCreator.GetTextBitmap("+", Color.Green, Color.Black);
        Image image2 = DummyDataCreator.GetTextBitmap("x", Color.Red, Color.Black);

        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is CellUIElement)
            {
                var progressBarEmbeddableUIElement = parent.GetDescendant(typeof(ProgressBarEmbeddableUIElement)) as ProgressBarEmbeddableUIElement;
                if (null != progressBarEmbeddableUIElement)
                {                    
                    var cell = parent.GetContext(typeof(UltraGridCell)) as UltraGridCell;                   
                    if (null != cell)                 
                    {
                        if (cell.Column.Key != "Int32 1")
                            return;

                        // Determine which images to use based on the Value of the cell. 
                        int cellValue = (int)cell.Value;
                        Image image = cellValue < 70
                            ? image1
                            : image2;

                        // Get an existing ImageUIElement if there is one, or else create a new one. 
                        var imageUIElement = parent.GetDescendant(typeof(ImageUIElement)) as ImageUIElement;
                        if (null == imageUIElement)
                        {
                            imageUIElement = new ImageUIElement(parent, image);
                            parent.ChildElements.Add(imageUIElement);
                        }
                        else
                        {
                            imageUIElement.Image = image;
                        }

                        // Position the image on the left edge of the cell. 
                        imageUIElement.Rect = new Rectangle(
                            parent.Rect.X, 
                            parent.Rect.Y, 
                            image.Width,
                            parent.Rect.Height
                            );

                        // Shift the progressBarEmbeddableUIElement to fill the rest of the cell. 
                        progressBarEmbeddableUIElement.Rect = new Rectangle(
                            imageUIElement.Rect.Right + 1,
                            parent.Rect.Y,
                            parent.Rect.Width - imageUIElement.Rect.Width,
                            parent.Rect.Height
                            );
                    }
                    else
                        Debug.Fail("Failed to get a celll unexpected.");
                }
            }
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            // Do nothing.
            return false;
        }
    }

}
